// Generated from player/lua/input.lua

"--[[\n"
"This file is part of mpv.\n"
"\n"
"mpv is free software; you can redistribute it and/or\n"
"modify it under the terms of the GNU Lesser General Public\n"
"License as published by the Free Software Foundation; either\n"
"version 2.1 of the License, or (at your option) any later version.\n"
"\n"
"mpv is distributed in the hope that it will be useful,\n"
"but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
"GNU Lesser General Public License for more details.\n"
"\n"
"You should have received a copy of the GNU Lesser General Public\n"
"License along with mpv.  If not, see <http://www.gnu.org/licenses/>.\n"
"]]\n"
"\n"
"local utils = require \"mp.utils\"\n"
"local input = {}\n"
"\n"
"local function register_event_handler(t)\n"
"    mp.register_script_message(\"input-event\", function (type, args)\n"
"        if t[type] then\n"
"            local suggestions, completion_start_position =\n"
"                t[type](unpack(utils.parse_json(args or \"\") or {}))\n"
"\n"
"            if type == \"complete\" and suggestions then\n"
"                mp.commandv(\"script-message-to\", \"console\", \"complete\",\n"
"                            utils.format_json(suggestions), completion_start_position)\n"
"            end\n"
"        end\n"
"\n"
"        if type == \"closed\" then\n"
"            mp.unregister_script_message(\"input-event\")\n"
"        end\n"
"    end)\n"
"end\n"
"\n"
"function input.get(t)\n"
"    mp.commandv(\"script-message-to\", \"console\", \"get-input\",\n"
"                mp.get_script_name(), utils.format_json({\n"
"                    prompt = t.prompt,\n"
"                    default_text = t.default_text,\n"
"                    cursor_position = t.cursor_position,\n"
"                    id = t.id,\n"
"                }))\n"
"\n"
"    register_event_handler(t)\n"
"end\n"
"\n"
"function input.select(t)\n"
"    mp.commandv(\"script-message-to\", \"console\", \"get-input\",\n"
"                mp.get_script_name(), utils.format_json({\n"
"                    prompt = t.prompt,\n"
"                    items = t.items,\n"
"                    default_item = t.default_item,\n"
"                }))\n"
"\n"
"    register_event_handler(t)\n"
"end\n"
"\n"
"function input.terminate()\n"
"    mp.commandv(\"script-message-to\", \"console\", \"disable\")\n"
"end\n"
"\n"
"function input.log(message, style, terminal_style)\n"
"    mp.commandv(\"script-message-to\", \"console\", \"log\", utils.format_json({\n"
"                   text = message,\n"
"                   style = style,\n"
"                   terminal_style = terminal_style,\n"
"               }))\n"
"end\n"
"\n"
"function input.log_error(message)\n"
"    mp.commandv(\"script-message-to\", \"console\", \"log\",\n"
"                 utils.format_json({ text = message, error = true }))\n"
"end\n"
"\n"
"function input.set_log(log)\n"
"    mp.commandv(\"script-message-to\", \"console\", \"set-log\", utils.format_json(log))\n"
"end\n"
"\n"
"return input\n"
